structure Top =
struct
  structure LPP = LambdaPlusPlus

  fun println s = print (s ^ "\n")

  fun parse_exp_and_print s =
    println (
      case LPP.parse_exp s of
        Sum.INL err => err
      | Sum.INR ast => LPP.pp_exp ast
    )

  fun parse_typ_and_print s =
    println (
      case LPP.parse_typ s of
        Sum.INL err => err
      | Sum.INR t => LPP.pp_typ t
    )

  fun eval exp_string =
    println ((
      case LPP.parse_exp exp_string of
        Sum.INL err => "Error parsing expression: " ^ err
      | Sum.INR exp => LPP.pp_exp (Dynamics.eval exp)
    ) handle Dynamics.TypeError => "Type error!")

end
